## geogram 1.8.5

=== CMakeLists.txt ===
##############################################################################
# Geogram/Vorpaline root CMakeList
##############################################################################

cmake_minimum_required(VERSION 3.0)
cmake_policy(SET CMP0048 NEW)

##############################################################################
set(VORPALINE_VERSION_RC FALSE)
set(VORPALINE_VERSION_MAJOR 1)
set(VORPALINE_VERSION_MINOR 8)
set(VORPALINE_VERSION_PATCH 5)

set(VORPALINE_VERSION_PLAIN ${VORPALINE_VERSION_MAJOR}.${VORPALINE_VERSION_MINOR}.${VORPALINE_VERSION_PATCH})
if(VORPALINE_VERSION_RC)
   set(VORPALINE_VERSION ${VORPALINE_VERSION_PLAIN}-rc)
else()
   set(VORPALINE_VERSION ${VORPALINE_VERSION_PLAIN})
endif()
##############################################################################

# Note: geogram.cmake defines GEOGRAM_WITH_VORPALINE
# that we could have used instead,
# but geogram.cmake needs to be included after the project()
# command, since project() resets CFLAGS and CXXFLAGS.

if(IS_DIRECTORY ${CMAKE_SOURCE_DIR}/src/lib/vorpalib)
   project(Vorpaline VERSION "${VORPALINE_VERSION_PLAIN}")
else()
   project(Geogram VERSION "${VORPALINE_VERSION_PLAIN}")
endif()

# Optional modules
# (can be overriden in CMakeOptions.txt)

# Set GEOGRAM_SUB_BUILD if Geogram sources included in buildtree, then
# VORPALINE_PLATFORM can be set directly in parent CMakeLists.txt
if(NOT GEOGRAM_SUB_BUILD)
   option(GEOGRAM_WITH_GRAPHICS "Viewers and geogram_gfx library" ON)
   option(GEOGRAM_WITH_LEGACY_NUMERICS "Legacy numerical libraries" ON)
   option(GEOGRAM_WITH_HLBFGS "Non-linear solver (Yang Liu's HLBFGS)" ON)
   option(GEOGRAM_WITH_TETGEN "Tetrahedral mesher (Hang Si's TetGen)" ON)
   option(GEOGRAM_WITH_TRIANGLE "Triangle mesher (Jonathan Shewchuk's triangle)" ON)
   option(GEOGRAM_WITH_LUA "Built-in LUA interpreter" ON)
   option(GEOGRAM_LIB_ONLY "Libraries only (no example programs/no viewer)" OFF)
   option(GEOGRAM_WITH_FPG "Predicate generator (Sylvain Pion's FPG)" OFF)
   option(GEOGRAM_USE_SYSTEM_GLFW3 "Use the version of GLFW3 installed in the system if found" OFF)
   option(GEOGRAM_WITH_GARGANTUA "64-bit indices" OFF)
   include(cmake/geo_detect_platform.cmake)
endif()

include(cmake/geogram.cmake)

# Override default CMAKE_INSTALL_DOCDIR: Use doc instead of CMake default DATAROOTDIR/doc/PROJECT_NAME
set(CMAKE_INSTALL_DOCDIR doc CACHE PATH "Documentation root")

# Set remaining CMAKE_INSTALL_...DIR variables
include(GNUInstallDirs)

# Install destinations for pkg-config and CMake files
set(GEOGRAM_INSTALL_PKGCONFIG_DIR ${CMAKE_INSTALL_LIBDIR}/pkgconfig CACHE PATH "pkg-config file install destination")
set(GEOGRAM_INSTALL_CMAKE_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/modules CACHE PATH "CMake file install destination")


set(VORPALINE_INCLUDE_SUBPATH geogram${VORPALINE_VERSION_MAJOR})

# Determine the current Build-OS (Build-platform without the compiler info)
string(REGEX REPLACE "-[^-]+$" "" VORPALINE_OS ${VORPALINE_PLATFORM})

# Determine the current build date
string(TIMESTAMP VORPALINE_BUILD_DATE "%Y-%m-%d %H:%M:%S")
string(TIMESTAMP YEAR "%Y")

# Determine the current build number
# This is set by Jenkins in environment variable BUILD_NUMBER
set(VORPALINE_BUILD_NUMBER $ENV{BUILD_NUMBER})

if(GEOGRAM_WITH_GARGANTUA)
  add_definitions(-DGARGANTUA)
endif()


##############################################################################
# Get SVN revision info

if(GEOGRAM_WITH_VORPALINE)
##  set(VORPALINE_SVN_REVISION ${Vorpaline_WC_REVISION})
endif()

##############################################################################
# RPATH (where executables find the .so / DLLs)
# - Enables RPATH support for MACOSX
# - Makes RPATH of dynamic libraries and executable point to the directory
#   where libraries are installed.

if(VORPALINE_BUILD_DYNAMIC)
   set(CMAKE_MACOSX_RPATH 1)
   set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
endif()

set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")

# uninstall target
# Needs to be created before add_subdirectory() because GLFw has
# also an uninstall target that will be inhibited if there is
# already one (Geogram's one needs to be first)

configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

##############################################################################
# Geogram/Vorpaline sources

add_subdirectory(src/lib/geogram)
if(GEOGRAM_WITH_VORPALINE)
   add_subdirectory(src/lib/vorpalib)
endif()

add_subdirectory(src/lib/third_party)

if(GEOGRAM_WITH_GRAPHICS)
  add_subdirectory(src/lib/geogram_gfx)
endif()

if(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/src/lib/exploragram)
  if(GEOGRAM_WITH_EXPLORAGRAM)
     add_subdirectory(src/lib/exploragram)
  endif()
endif()

if(NOT GEOGRAM_LIB_ONLY)
  add_subdirectory(src/bin)
  add_subdirectory(src/tests)
  add_subdirectory(src/examples)
  add_subdirectory(tests)
endif()

add_subdirectory(doc)

##############################################################################
# Cleanup from previous builds

file(REMOVE ${CMAKE_BINARY_DIR}/doc/LICENSE.txt)


##############################################################################
# Geogram installation


# FindGeogram.cmake

install(FILES cmake/FindGeogram.cmake DESTINATION ${GEOGRAM_INSTALL_CMAKE_DIR} COMPONENT devkit)

# Configure CPack

set(CPACK_PACKAGE_NAME ${CMAKE_PROJECT_NAME})
set(CPACK_SYSTEM_NAME ${VORPALINE_OS})
set(CPACK_PACKAGE_VENDOR "INRIA - ALICE")


if(${GEOGRAM_WITH_VORPALINE})
    set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "A flexible mesh generator")
else()
    set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "fast, simple and easy-to-use primitives for geometric programming")
endif()

set(CPACK_PACKAGE_VERSION_MAJOR ${VORPALINE_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${VORPALINE_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${VORPALINE_VERSION_PATCH})
set(CPACK_PACKAGE_VERSION ${VORPALINE_VERSION})
set(CPACK_PACKAGE_FILE_NAME ${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION})
set(CPACK_COMPONENT_INCLUDE_TOPLEVEL_DIRECTORY true)

if(CPACK_GENERATOR STREQUAL "DEB")
  set(CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
  set(CPACK_PACKAGE_CONTACT Bruno.Levy@inria.fr)
# set(CPACK_PACKAGE_DEPENDS "libglfw3 (>= 3.2-1), libc6 (>= 2.22-11), libstdc++ (>= 6.1.1-4)")
#   TODO: use objdump -p | grep NEEDED to automate...
#   or GET_PROPERTY(result GLOBAL ENABLED_FEATURES)  (successful FIND_PACKAGE())
endif()

if(NOT DEFINED CPACK_GENERATOR)
  if(WIN32)
    set(CPACK_GENERATOR ZIP)
  else()
    set(CPACK_GENERATOR TGZ)
  endif()
endif()

# Enable component-based packaging for archive generators (TGZ, ZIP)
set(CPACK_ARCHIVE_COMPONENT_INSTALL ON)

set(CPACK_COMPONENTS_ALL runtime devkit devkit-full doc-devkit doc-devkit-full)
set(CPACK_COMPONENTS_GROUPING "IGNORE")

set(CPACK_COMPONENT_RUNTIME_DISPLAY_NAME "Vorpaline Application")
set(CPACK_COMPONENT_RUNTIME_GROUP "Runtime")

set(CPACK_COMPONENT_DEVKIT_DISPLAY_NAME "Vorpaline Developer Kit")
set(CPACK_COMPONENT_DEVKIT_GROUP "Development")

set(CPACK_COMPONENT_DEVKIT-FULL_DISPLAY_NAME "Vorpaline Full Developer Kit")
set(CPACK_COMPONENT_DEVKIT-FULL_GROUP "Development")

set(CPACK_COMPONENT_DOC-DEVKIT_DISPLAY_NAME "Vorpaline API Developer Kit Documentation")
set(CPACK_COMPONENT_DOC-DEVKIT_GROUP "Documentation")

set(CPACK_COMPONENT_DOC-DEVKIT-FULL_DISPLAY_NAME "Vorpaline Full Developer Kit Documentation")
set(CPACK_COMPONENT_DOC-DEVKIT-FULL_GROUP "Documentation")

set(CPACK_COMPONENT_DOC-DEVKIT-INTERNAL_DISPLAY_NAME "Vorpaline Internal Developer Kit Documentation")
set(CPACK_COMPONENT_DOC-DEVKIT-INTERNAL_GROUP "Documentation")

# Copy the helper script to build individual packages to the binary directory
configure_file(
    tools/make_package.pl.in
    make_package.pl
    @ONLY
)

# This must always be last!
include(CPack)

=== doc/CMakeLists.txt ===
#
# Build rules for the documentation
#

include(${PROJECT_SOURCE_DIR}/cmake/doxygen.cmake)

cmake_minimum_required(VERSION 2.8.12)




if(DOXYGEN_FOUND)

  # Add a custom documentation targets

  add_doc_target(devkit)
  add_doc_target(devkit-full)
  add_doc_target(devkit-internal)
  add_doc_target(devkit-internal-light)

  # TODO: add end-user documentation

  # Copy the Version info file to the build directory
  configure_file(VERSION.txt.in VERSION.txt @ONLY)

  # Install documentation
  if(GEOGRAM_WITH_VORPALINE)
      install(FILES README.txt DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT runtime)
      install(FILES ${CMAKE_CURRENT_BINARY_DIR}/LICENSE.txt DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT runtime OPTIONAL)
  endif()

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/VERSION.txt DESTINATION ${CMAKE_INSTALL_DOCDIR}/geogram COMPONENT runtime OPTIONAL)

  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/devkit/html DESTINATION ${CMAKE_INSTALL_DOCDIR}/devkit COMPONENT doc-devkit OPTIONAL)
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/devkit-full/html DESTINATION ${CMAKE_INSTALL_DOCDIR}/devkit COMPONENT doc-devkit-full OPTIONAL)
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/devkit-internal/html DESTINATION ${CMAKE_INSTALL_DOCDIR}/devkit COMPONENT doc-devkit-internal OPTIONAL)

endif()

=== tests/CMakeLists.txt ===
# Copy the RobotFramework wrapper scripts to the build directory

set(test_scripts testenv runpybot runride)

foreach(script ${test_scripts})
    configure_file_with_native_paths(
        ${PROJECT_SOURCE_DIR}/tools/${script}.${SHELL_SUFFIX}.in
        ${PROJECT_BINARY_DIR}/tests/${script}.${SHELL_SUFFIX}
        AUTODETECT
        OPTIONS @ONLY
    )
endforeach()

# Copy the valgrind suppression file to the build directory

if(UNIX)
    configure_file(
        ${PROJECT_SOURCE_DIR}/tools/valgrind.supp
        ${PROJECT_BINARY_DIR}/tests/valgrind.supp
        COPYONLY
    )
endif()

=== src/bin/CMakeLists.txt ===

add_subdirectory(vorpastat)
add_subdirectory(vorpacomp)
add_subdirectory(geodump)

if(GEOGRAM_WITH_GRAPHICS)
  add_subdirectory(vorpaview)
  add_subdirectory(geobox)
  if(GEOGRAM_WITH_LUA)  
     add_subdirectory(geocod)
  endif()   
  add_subdirectory(geoshade)
endif()

add_subdirectory(vorpalite)

# if(GEOGRAM_WITH_VORPALINE) 
#  add_subdirectory(vorpaline)
# endif()

if(GEOGRAM_WITH_FPG)
  add_subdirectory(fpg)
  add_subdirectory(pck)  
endif()

=== src/examples/CMakeLists.txt ===

add_subdirectory(geogram)

if(GEOGRAM_WITH_GRAPHICS)
   add_subdirectory(graphics)
endif() 

if(GEOGRAM_WITH_EXPLORAGRAM)
   add_subdirectory(exploragram)
endif()   

#if(GEOGRAM_WITH_VORPALINE)
#   add_subdirectory(vorpaline)
#endif()

=== src/tests/CMakeLists.txt ===
add_subdirectory(test_nn_search)
add_subdirectory(test_convex_cell)
add_subdirectory(bench_load)
add_subdirectory(test_locks)
add_subdirectory(test_expansion_nt)
add_subdirectory(test_HLBFGS)
add_subdirectory(test_RVC)
add_subdirectory(test_logger)
add_subdirectory(test_CDT_2d)

=== src/bin/geobox/CMakeLists.txt ===
include(${PROJECT_SOURCE_DIR}/cmake/opengl.cmake)

aux_source_directories(SOURCES "" .)
add_executable(geobox ${SOURCES})
target_link_libraries(geobox geogram_gfx geogram ${GLFW_LIBRARIES})
install_runtime_targets(geobox)

set_target_properties(geobox PROPERTIES FOLDER "GEOGRAM/Programs")

=== src/bin/geodump/CMakeLists.txt ===
set(APP_NAME geodump)
aux_source_directories(SOURCES "" .)
vor_add_executable(${APP_NAME} ${SOURCES})
target_link_libraries(${APP_NAME} geogram)
install_runtime_targets(${APP_NAME})

set_target_properties(${APP_NAME} PROPERTIES FOLDER "GEOGRAM/Programs")

=== src/bin/pck/CMakeLists.txt ===
set(APP_NAME pck)
aux_source_directories(SOURCES "" .)
vor_add_executable(${APP_NAME} ${SOURCES})
target_link_libraries(${APP_NAME} geogram)
install_runtime_targets(${APP_NAME})

set_target_properties(${APP_NAME} PROPERTIES FOLDER "GEOGRAM/Programs")

=== src/bin/vorpacomp/CMakeLists.txt ===
set(APP_NAME vorpacomp)
aux_source_directories(SOURCES "" .)
vor_add_executable(${APP_NAME} ${SOURCES})
target_link_libraries(${APP_NAME} geogram)

set_target_properties(${APP_NAME} PROPERTIES FOLDER "GEOGRAM/Programs")

=== src/bin/vorpalite/CMakeLists.txt ===
set(APP_NAME vorpalite)
aux_source_directories(SOURCES "" .)
vor_add_executable(${APP_NAME} ${SOURCES})
target_link_libraries(${APP_NAME} geogram)

install_runtime_targets(${APP_NAME})

set_target_properties(${APP_NAME} PROPERTIES FOLDER "GEOGRAM/Programs")

=== src/bin/vorpastat/CMakeLists.txt ===
set(APP_NAME vorpastat)
aux_source_directories(SOURCES "" .)
vor_add_executable(${APP_NAME} ${SOURCES})
target_link_libraries(${APP_NAME} geogram)

set_target_properties(${APP_NAME} PROPERTIES FOLDER "GEOGRAM/Programs")

=== debian/changelog ===
geogram (1.8.5-1) unstable; urgency=medium

  * First release into Debian (Closes: #1015761)

 -- Dima Kogan <dkogan@debian.org>  Thu, 28 Jul 2022 00:14:27 -0700

=== debian/control ===
Source: geogram
Section: contrib/libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libtriangle-dev,
               libstb-dev,
               liblua5.4-dev,
               libann-dev,
               zlib1g-dev,
               libamgcl-dev,
               doxygen
Standards-Version: 4.6.0
Homepage: https://github.com/BrunoLevy/geogram
Vcs-Git: https://salsa.debian.org/science-team/geogram.git
Vcs-Browser: https://salsa.debian.org/science-team/geogram

Package: libgeogram1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Programming library with geometric algorithms
 Contains the main results in Geometry Processing from the former ALICE Inria
 project, that is, more than 30 research articles published in ACM SIGGRAPH, ACM
 Transactions on Graphics, Symposium on Geometry Processing and Eurographics.
 .
 Geogram includes a simple yet efficient Mesh data structure (for surfacic and
 volumetric meshes), exact computer arithmetics (a-la Shewchuck, implemented in
 GEO::expansion), a predicate code generator (PCK: the Predicate Construction
 Kit), standard geometric predicates (orient/insphere), Delaunay triangulation,
 Voronoi diagram, spatial search data structures, spatial sorting) and less
 standard ones (more general geometric predicates, intersection between a
 Voronoi diagram and a triangular or tetrahedral mesh embedded in n dimensions),
 and semi-discrete optimal transport.
 .
 This package provides the shared library

Package: libgeogram-dev
Section: contrib/libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libgeogram1 (= ${binary:Version}),
         libeigen3-dev,
         libopenscenegraph-dev
Suggests: libgeogram-doc, geogram
Description: Programming library with geometric algorithms
 Contains the main results in Geometry Processing from the former ALICE Inria
 project, that is, more than 30 research articles published in ACM SIGGRAPH, ACM
 Transactions on Graphics, Symposium on Geometry Processing and Eurographics.
 .
 Geogram includes a simple yet efficient Mesh data structure (for surfacic and
 volumetric meshes), exact computer arithmetics (a-la Shewchuck, implemented in
 GEO::expansion), a predicate code generator (PCK: the Predicate Construction
 Kit), standard geometric predicates (orient/insphere), Delaunay triangulation,
 Voronoi diagram, spatial search data structures, spatial sorting) and less
 standard ones (more general geometric predicates, intersection between a
 Voronoi diagram and a triangular or tetrahedral mesh embedded in n dimensions),
 and semi-discrete optimal transport.
 .
 This package provides the development files library

Package: geogram
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgeogram1 (= ${binary:Version})
Description: Programming library with geometric algorithms
 Contains the main results in Geometry Processing from the former ALICE Inria
 project, that is, more than 30 research articles published in ACM SIGGRAPH, ACM
 Transactions on Graphics, Symposium on Geometry Processing and Eurographics.
 .
 Geogram includes a simple yet efficient Mesh data structure (for surfacic and
 volumetric meshes), exact computer arithmetics (a-la Shewchuck, implemented in
 GEO::expansion), a predicate code generator (PCK: the Predicate Construction
 Kit), standard geometric predicates (orient/insphere), Delaunay triangulation,
 Voronoi diagram, spatial search data structures, spatial sorting) and less
 standard ones (more general geometric predicates, intersection between a
 Voronoi diagram and a triangular or tetrahedral mesh embedded in n dimensions),
 and semi-discrete optimal transport.
 .
 This package provides the executable tools

Package: libgeogram-doc
Architecture: all
Depends: ${misc:Depends}
Section: contrib/doc
Suggests: libgeogram-dev (= ${binary:Version}), geogram (= ${binary:Version})
Description: Programming library with geometric algorithms
 Contains the main results in Geometry Processing from the former ALICE Inria
 project, that is, more than 30 research articles published in ACM SIGGRAPH, ACM
 Transactions on Graphics, Symposium on Geometry Processing and Eurographics.
 .
 Geogram includes a simple yet efficient Mesh data structure (for surfacic and
 volumetric meshes), exact computer arithmetics (a-la Shewchuck, implemented in
 GEO::expansion), a predicate code generator (PCK: the Predicate Construction
 Kit), standard geometric predicates (orient/insphere), Delaunay triangulation,
 Voronoi diagram, spatial search data structures, spatial sorting) and less
 standard ones (more general geometric predicates, intersection between a
 Voronoi diagram and a triangular or tetrahedral mesh embedded in n dimensions),
 and semi-discrete optimal transport.
 .
 This package provides the HTML documentation

## geogram 1.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,20 +2,21 @@
 # Geogram/Vorpaline root CMakeList
 ##############################################################################
 
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.5)
 cmake_policy(SET CMP0048 NEW)
+
 
 ##############################################################################
 set(VORPALINE_VERSION_RC FALSE)
 set(VORPALINE_VERSION_MAJOR 1)
-set(VORPALINE_VERSION_MINOR 8)
-set(VORPALINE_VERSION_PATCH 5)
+set(VORPALINE_VERSION_MINOR 9)
+set(VORPALINE_VERSION_PATCH 2)
 
 set(VORPALINE_VERSION_PLAIN ${VORPALINE_VERSION_MAJOR}.${VORPALINE_VERSION_MINOR}.${VORPALINE_VERSION_PATCH})
 if(VORPALINE_VERSION_RC)
-   set(VORPALINE_VERSION ${VORPALINE_VERSION_PLAIN}-rc)
-else()
-   set(VORPALINE_VERSION ${VORPALINE_VERSION_PLAIN})
+set(VORPALINE_VERSION ${VORPALINE_VERSION_PLAIN}-rc)
+else()
+set(VORPALINE_VERSION ${VORPALINE_VERSION_PLAIN})
 endif()
 ##############################################################################
 
@@ -25,9 +26,9 @@
 # command, since project() resets CFLAGS and CXXFLAGS.
 
 if(IS_DIRECTORY ${CMAKE_SOURCE_DIR}/src/lib/vorpalib)
-   project(Vorpaline VERSION "${VORPALINE_VERSION_PLAIN}")
-else()
-   project(Geogram VERSION "${VORPALINE_VERSION_PLAIN}")
+project(Vorpaline VERSION "${VORPALINE_VERSION_PLAIN}")
+else()
+project(Geogram VERSION "${VORPALINE_VERSION_PLAIN}")
 endif()
 
 # Optional modules
@@ -36,17 +37,22 @@
 # Set GEOGRAM_SUB_BUILD if Geogram sources included in buildtree, then
 # VORPALINE_PLATFORM can be set directly in parent CMakeLists.txt
 if(NOT GEOGRAM_SUB_BUILD)
-   option(GEOGRAM_WITH_GRAPHICS "Viewers and geogram_gfx library" ON)
-   option(GEOGRAM_WITH_LEGACY_NUMERICS "Legacy numerical libraries" ON)
-   option(GEOGRAM_WITH_HLBFGS "Non-linear solver (Yang Liu's HLBFGS)" ON)
-   option(GEOGRAM_WITH_TETGEN "Tetrahedral mesher (Hang Si's TetGen)" ON)
-   option(GEOGRAM_WITH_TRIANGLE "Triangle mesher (Jonathan Shewchuk's triangle)" ON)
-   option(GEOGRAM_WITH_LUA "Built-in LUA interpreter" ON)
-   option(GEOGRAM_LIB_ONLY "Libraries only (no example programs/no viewer)" OFF)
-   option(GEOGRAM_WITH_FPG "Predicate generator (Sylvain Pion's FPG)" OFF)
-   option(GEOGRAM_USE_SYSTEM_GLFW3 "Use the version of GLFW3 installed in the system if found" OFF)
-   option(GEOGRAM_WITH_GARGANTUA "64-bit indices" OFF)
-   include(cmake/geo_detect_platform.cmake)
+option(GEOGRAM_WITH_GRAPHICS "Viewers and geogram_gfx library" ON)
+option(GEOGRAM_WITH_LEGACY_NUMERICS "Legacy numerical libraries" ON)
+option(GEOGRAM_WITH_HLBFGS "Non-linear solver (Yang Liu's HLBFGS)" ON)
+option(GEOGRAM_WITH_TETGEN "Tetrahedral mesher (Hang Si's TetGen)" ON)
+option(GEOGRAM_WITH_TRIANGLE "Triangle mesher (Jonathan Shewchuk's triangle)" ON)
+option(GEOGRAM_WITH_LUA "Built-in LUA interpreter" ON)
+option(GEOGRAM_LIB_ONLY "Libraries only (no example programs/no viewer)" OFF)
+option(GEOGRAM_WITH_FPG "Predicate generator (Sylvain Pion's FPG)" OFF)
+option(GEOGRAM_USE_SYSTEM_GLFW3 "Use the version of GLFW3 installed in the system if found" OFF)
+option(GEOGRAM_WITH_GARGANTUA "64-bit indices" OFF)
+option(GEOGRAM_WITH_TBB "Use TBB for multi-threading" OFF)
+include(cmake/geo_detect_platform.cmake)
+endif()
+
+if(GEOGRAM_WITH_TBB AND NOT TARGET TBB::tbb)
+include(cmake/onetbb.cmake)
 endif()
 
 include(cmake/geogram.cmake)
@@ -76,7 +82,7 @@
 set(VORPALINE_BUILD_NUMBER $ENV{BUILD_NUMBER})
 
 if(GEOGRAM_WITH_GARGANTUA)
-  add_definitions(-DGARGANTUA)
+add_definitions(-DGARGANTUA)
 endif()
 
 
@@ -94,8 +100,8 @@
 #   where libraries are installed.
 
 if(VORPALINE_BUILD_DYNAMIC)
-   set(CMAKE_MACOSX_RPATH 1)
-   set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
+set(CMAKE_MACOSX_RPATH 1)
+set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
 endif()
 
 set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
@@ -106,38 +112,38 @@
 # already one (Geogram's one needs to be first)
 
 configure_file(
-    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
-    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
-    IMMEDIATE @ONLY)
+"${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
+"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
+IMMEDIATE @ONLY)
 
 add_custom_target(uninstall
-    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
+COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
 
 ##############################################################################
 # Geogram/Vorpaline sources
 
 add_subdirectory(src/lib/geogram)
 if(GEOGRAM_WITH_VORPALINE)
-   add_subdirectory(src/lib/vorpalib)
+add_subdirectory(src/lib/vorpalib)
 endif()
 
 add_subdirectory(src/lib/third_party)
 
 if(GEOGRAM_WITH_GRAPHICS)
-  add_subdirectory(src/lib/geogram_gfx)
+add_subdirectory(src/lib/geogram_gfx)
 endif()
 
 if(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/src/lib/exploragram)
-  if(GEOGRAM_WITH_EXPLORAGRAM)
-     add_subdirectory(src/lib/exploragram)
-  endif()
+if(GEOGRAM_WITH_EXPLORAGRAM)
+add_subdirectory(src/lib/exploragram)
+endif()
 endif()
 
 if(NOT GEOGRAM_LIB_ONLY)
-  add_subdirectory(src/bin)
-  add_subdirectory(src/tests)
-  add_subdirectory(src/examples)
-  add_subdirectory(tests)
+add_subdirectory(src/bin)
+add_subdirectory(src/tests)
+add_subdirectory(src/examples)
+add_subdirectory(tests)
 endif()
 
 add_subdirectory(doc)
@@ -164,9 +170,9 @@
 
 
 if(${GEOGRAM_WITH_VORPALINE})
-    set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "A flexible mesh generator")
-else()
-    set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "fast, simple and easy-to-use primitives for geometric programming")
+set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "A flexible mesh generator")
+else()
+set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "fast, simple and easy-to-use primitives for geometric programming")
 endif()
 
 set(CPACK_PACKAGE_VERSION_MAJOR ${VORPALINE_VERSION_MAJOR})
@@ -177,19 +183,19 @@
 set(CPACK_COMPONENT_INCLUDE_TOPLEVEL_DIRECTORY true)
 
 if(CPACK_GENERATOR STREQUAL "DEB")
-  set(CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
-  set(CPACK_PACKAGE_CONTACT Bruno.Levy@inria.fr)
+set(CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
+set(CPACK_PACKAGE_CONTACT Bruno.Levy@inria.fr)
 # set(CPACK_PACKAGE_DEPENDS "libglfw3 (>= 3.2-1), libc6 (>= 2.22-11), libstdc++ (>= 6.1.1-4)")
 #   TODO: use objdump -p | grep NEEDED to automate...
 #   or GET_PROPERTY(result GLOBAL ENABLED_FEATURES)  (successful FIND_PACKAGE())
 endif()
 
 if(NOT DEFINED CPACK_GENERATOR)
-  if(WIN32)
-    set(CPACK_GENERATOR ZIP)
-  else()
-    set(CPACK_GENERATOR TGZ)
-  endif()
+if(WIN32)
+set(CPACK_GENERATOR ZIP)
+else()
+set(CPACK_GENERATOR TGZ)
+endif()
 endif()
 
 # Enable component-based packaging for archive generators (TGZ, ZIP)
@@ -218,12 +224,10 @@
 
 # Copy the helper script to build individual packages to the binary directory
 configure_file(
-    tools/make_package.pl.in
-    make_package.pl
-    @ONLY
+tools/make_package.pl.in
+make_package.pl
+@ONLY
 )
 
 # This must always be last!
 include(CPack)
-
-

=== doc/CMakeLists.txt ===
#
# Build rules for the documentation
#

include(${PROJECT_SOURCE_DIR}/cmake/doxygen.cmake)

cmake_minimum_required(VERSION 3.5)




if(DOXYGEN_FOUND)

# Add a custom documentation targets

add_doc_target(devkit)
add_doc_target(devkit-full)
add_doc_target(devkit-internal)
add_doc_target(devkit-internal-light)

# TODO: add end-user documentation

# Copy the Version info file to the build directory
configure_file(VERSION.txt.in VERSION.txt @ONLY)

# Install documentation
if(GEOGRAM_WITH_VORPALINE)
install(FILES README.txt DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT runtime)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/LICENSE.txt DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT runtime OPTIONAL)
endif()

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/VERSION.txt DESTINATION ${CMAKE_INSTALL_DOCDIR}/geogram COMPONENT runtime OPTIONAL)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/devkit/html DESTINATION ${CMAKE_INSTALL_DOCDIR}/devkit COMPONENT doc-devkit OPTIONAL)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/devkit-full/html DESTINATION ${CMAKE_INSTALL_DOCDIR}/devkit COMPONENT doc-devkit-full OPTIONAL)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/devkit-internal/html DESTINATION ${CMAKE_INSTALL_DOCDIR}/devkit COMPONENT doc-devkit-internal OPTIONAL)

endif()

=== tests/CMakeLists.txt ===
# Copy the RobotFramework wrapper scripts to the build directory

set(test_scripts testenv runpybot runride)

foreach(script ${test_scripts})
configure_file_with_native_paths(
${PROJECT_SOURCE_DIR}/tools/${script}.${SHELL_SUFFIX}.in
${PROJECT_BINARY_DIR}/tests/${script}.${SHELL_SUFFIX}
AUTODETECT
OPTIONS @ONLY
)
endforeach()

# Copy the valgrind suppression file to the build directory

if(UNIX)
configure_file(
${PROJECT_SOURCE_DIR}/tools/valgrind.supp
${PROJECT_BINARY_DIR}/tests/valgrind.supp
COPYONLY
)
endif()

=== src/bin/geocod/CMakeLists.txt ===
include(${PROJECT_SOURCE_DIR}/cmake/opengl.cmake)
set(APP_NAME geocod)

aux_source_directories(SOURCES "" .)
aux_source_directories(SOURCES "lua" lua)
add_executable(${APP_NAME} ${SOURCES})
target_link_libraries(${APP_NAME} geogram_gfx geogram ${GLFW_LIBRARIES})
install_runtime_targets(${APP_NAME})

set_target_properties(${APP_NAME} PROPERTIES FOLDER "GEOGRAM/Programs")

=== src/examples/exploragram/CMakeLists.txt ===
add_subdirectory(hexdom_pipeline)
add_subdirectory(compute_OTM)

=== src/lib/geogram_gfx/CMakeLists.txt ===
include(${PROJECT_SOURCE_DIR}/cmake/opengl.cmake)

configure_file(geogram_gfx.pc.in ${PROJECT_BINARY_DIR}/geogram_gfx${VORPALINE_VERSION_MAJOR}.pc @ONLY)

add_definitions(-DIMGUI_USER_CONFIG="geogram_imconfig.h")

add_subdirectory(third_party)

aux_source_directories(SOURCES "Source Files"                .)
aux_source_directories(SOURCES "Source Files\\imgui_ext"     imgui_ext)
aux_source_directories(SOURCES "Source Files\\api"           api)
aux_source_directories(SOURCES "Source Files\\basic"         basic)
aux_source_directories(SOURCES "Source Files\\mesh"          mesh)
aux_source_directories(SOURCES "Source Files\\GLUP"          GLUP)
aux_source_directories(SOURCES "Source Files\\GLUP\\shaders" GLUP/shaders)
aux_source_directories(SOURCES "Source Files\\full_screen_effects" full_screen_effects)
aux_source_directories(SOURCES "Source Files\\gui"           gui)

if(GEOGRAM_WITH_LUA)
aux_source_directories(SOURCES "Source Files\\lua"           lua)
endif()

if(GEOGRAM_USE_SYSTEM_GLFW3)
add_definitions(-DGEO_USE_SYSTEM_GLFW3)
endif()

add_library(geogram_gfx ${SOURCES} $<TARGET_OBJECTS:geogram_gfx_third_party>)

target_include_directories(geogram_gfx PUBLIC ${PROJECT_SOURCE_DIR}/src/lib/geogram_gfx/third_party)
target_include_directories(geogram_gfx PRIVATE ${PROJECT_SOURCE_DIR}/src/lib/geogram_gfx/third_party/imgui)

if(ANDROID)
target_include_directories(geogram_gfx PRIVATE
${ANDROID_NDK}/sources/android/native_app_glue
)
message(STATUS "building for Android")
endif()

set_target_properties(geogram_gfx PROPERTIES
VERSION ${VORPALINE_VERSION}
SOVERSION ${VORPALINE_VERSION_MAJOR}
FOLDER "GEOGRAM")

if(NOT ANDROID)
target_link_libraries(geogram_gfx glfw)
endif()

if(VORPALINE_BUILD_DYNAMIC)
# Must provide all symbols at link time
target_link_libraries(geogram_gfx geogram)
target_link_libraries(geogram_gfx ${OPENGL_LIBRARIES})
endif()

# Install the library
install_devkit_targets(geogram_gfx)

# Install include files for the standard devkit
install(
DIRECTORY .
DESTINATION include/${VORPALINE_INCLUDE_SUBPATH}/geogram_gfx
COMPONENT devkit
FILES_MATCHING PATTERN *.h
)

# Install include files for the full devkit
install(
DIRECTORY .
DESTINATION include/${VORPALINE_INCLUDE_SUBPATH}/geogram_gfx
COMPONENT devkit-full
FILES_MATCHING PATTERN *.h
)

install(
FILES "${PROJECT_BINARY_DIR}/geogram_gfx${VORPALINE_VERSION_MAJOR}.pc"
DESTINATION lib${LIB_SUFFIX}/pkgconfig
)

=== src/tests/test_HLBFGS/CMakeLists.txt ===
aux_source_directories(SOURCES "" .)
vor_add_executable(test_HLBFGS ${SOURCES})
target_link_libraries(test_HLBFGS geogram)

set_target_properties(test_HLBFGS PROPERTIES FOLDER "GEOGRAM/Tests")

=== src/examples/geogram/boolean_operations/CMakeLists.txt ===
set(APP_NAME boolean_op)

aux_source_directories(SOURCES "" .)
vor_add_executable(${APP_NAME} ${SOURCES})
target_link_libraries(${APP_NAME} geogram)

set_target_properties(${APP_NAME} PROPERTIES FOLDER "GEOGRAM/Examples")

=== src/examples/geogram/opennl_LSCM/CMakeLists.txt ===
set(APP_NAME opennl_LSCM)

aux_source_directories(SOURCES "" .)
vor_add_executable(${APP_NAME} ${SOURCES})
target_link_libraries(${APP_NAME} geogram)

set_target_properties(${APP_NAME} PROPERTIES FOLDER "GEOGRAM/Examples")

=== src/examples/graphics/demo_Delaunay3d/CMakeLists.txt ===
include(${PROJECT_SOURCE_DIR}/cmake/opengl.cmake)
set(APP_NAME geogram_demo_Delaunay3d)

aux_source_directories(SOURCES "" .)
add_executable(${APP_NAME} ${SOURCES})
target_link_libraries(${APP_NAME} geogram_gfx geogram ${GLFW_LIBRARIES})
install_runtime_targets(${APP_NAME})

set_target_properties(${APP_NAME} PROPERTIES FOLDER "GEOGRAM/Examples")

=== src/examples/graphics/demo_GLUP/CMakeLists.txt ===
include(${PROJECT_SOURCE_DIR}/cmake/opengl.cmake)
set(APP_NAME geogram_demo_GLUP)

aux_source_directories(SOURCES "" .)
add_executable(${APP_NAME} ${SOURCES})
target_link_libraries(${APP_NAME} geogram_gfx geogram ${GLFW_LIBRARIES})
install_runtime_targets(${APP_NAME})

set_target_properties(${APP_NAME} PROPERTIES FOLDER "GEOGRAM/Examples")

=== src/tutorial/01_basics/hello_geogram/CMakeLists.txt ===
# Instructions to compile this program
# are explained in tutorials/README.txt

cmake_minimum_required(VERSION 2.8.11)
project(hello_geogram)

if (NOT CMAKE_BUILD_TYPE)
message (STATUS "No build type selected, default to Release")
set (CMAKE_BUILD_TYPE "Release")
endif ()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR})
find_package(Geogram REQUIRED)

add_executable(hello_geogram main.cpp)
target_link_libraries(hello_geogram Geogram::geogram)

=== debian/changelog ===
geogram (1.9.2-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Mon, 13 Jan 2025 22:37:52 -0800

## geogram 1.9.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # Geogram/Vorpaline root CMakeList
 ##############################################################################
 
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.5...3.30)
 cmake_policy(SET CMP0048 NEW)
 
 
@@ -10,7 +10,7 @@
 set(VORPALINE_VERSION_RC FALSE)
 set(VORPALINE_VERSION_MAJOR 1)
 set(VORPALINE_VERSION_MINOR 9)
-set(VORPALINE_VERSION_PATCH 2)
+set(VORPALINE_VERSION_PATCH 6)
 
 set(VORPALINE_VERSION_PLAIN ${VORPALINE_VERSION_MAJOR}.${VORPALINE_VERSION_MINOR}.${VORPALINE_VERSION_PATCH})
 if(VORPALINE_VERSION_RC)

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 include(${PROJECT_SOURCE_DIR}/cmake/doxygen.cmake)
 
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.5...3.30)

=== src/bin/CMakeLists.txt ===

add_subdirectory(vorpastat)
add_subdirectory(vorpacomp)
add_subdirectory(geodump)

if(GEOGRAM_WITH_GRAPHICS)
add_subdirectory(vorpaview)
add_subdirectory(geobox)
add_subdirectory(geoCSG)
if(GEOGRAM_WITH_LUA)
add_subdirectory(geocod)
endif()
add_subdirectory(geoshade)
endif()

add_subdirectory(vorpalite)

# if(GEOGRAM_WITH_VORPALINE)
#  add_subdirectory(vorpaline)
# endif()

if(GEOGRAM_WITH_FPG)
add_subdirectory(fpg)
add_subdirectory(pck)
endif()

=== src/examples/CMakeLists.txt ===

add_subdirectory(geogram)

if(GEOGRAM_WITH_GRAPHICS)
add_subdirectory(graphics)
endif()

if(GEOGRAM_WITH_EXPLORAGRAM)
add_subdirectory(exploragram)
endif()

#if(GEOGRAM_WITH_VORPALINE)
#   add_subdirectory(vorpaline)
#endif()

=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -7,3 +7,6 @@
 add_subdirectory(test_RVC)
 add_subdirectory(test_logger)
 add_subdirectory(test_CDT_2d)
+add_subdirectory(test_geofile)
+add_subdirectory(test_mesh_syntaxic_sugar)
+

=== src/bin/fpg/CMakeLists.txt ===
vor_reset_warning_level()
set(APP_NAME mcc)
aux_source_directories(SOURCES "" .)
include_directories(.)
vor_add_executable(${APP_NAME} ${SOURCES})
target_link_libraries(${APP_NAME} geogram)

set_target_properties(${APP_NAME} PROPERTIES FOLDER "GEOGRAM/Programs")

=== src/bin/geoCSG/CMakeLists.txt ===
include(${PROJECT_SOURCE_DIR}/cmake/opengl.cmake)
set(APP_NAME geoCSG)

aux_source_directories(SOURCES "" .)
add_executable(${APP_NAME} ${SOURCES})
target_link_libraries(${APP_NAME} geogram_gfx geogram ${GLFW_LIBRARIES})
install_runtime_targets(${APP_NAME})

set_target_properties(${APP_NAME} PROPERTIES FOLDER "GEOGRAM/Programs")

=== src/bin/geodump/CMakeLists.txt ===
--- 
+++ 
@@ -5,4 +5,3 @@
 install_runtime_targets(${APP_NAME})
 
 set_target_properties(${APP_NAME} PROPERTIES FOLDER "GEOGRAM/Programs")
-

=== src/bin/geoshade/CMakeLists.txt ===
include(${PROJECT_SOURCE_DIR}/cmake/opengl.cmake)
set(APP_NAME geoshade)

aux_source_directories(SOURCES "" .)
aux_source_directories(SOURCES "glsl" glsl)
add_executable(${APP_NAME} ${SOURCES})
target_link_libraries(${APP_NAME} geogram_gfx geogram ${GLFW_LIBRARIES})
install_runtime_targets(${APP_NAME})

set_target_properties(${APP_NAME} PROPERTIES FOLDER "GEOGRAM/Programs")

=== src/bin/pck/CMakeLists.txt ===
--- 
+++ 
@@ -5,4 +5,3 @@
 install_runtime_targets(${APP_NAME})
 
 set_target_properties(${APP_NAME} PROPERTIES FOLDER "GEOGRAM/Programs")
-

=== src/bin/vorpacomp/CMakeLists.txt ===
--- 
+++ 
@@ -4,4 +4,3 @@
 target_link_libraries(${APP_NAME} geogram)
 
 set_target_properties(${APP_NAME} PROPERTIES FOLDER "GEOGRAM/Programs")
-

=== src/bin/vorpalite/CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,3 @@
 install_runtime_targets(${APP_NAME})
 
 set_target_properties(${APP_NAME} PROPERTIES FOLDER "GEOGRAM/Programs")
-
-
-

=== debian/changelog ===
geogram (1.9.6-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Fri, 22 Aug 2025 16:10:21 -0700

=== debian/control ===
--- 
+++ 
@@ -11,6 +11,8 @@
                libann-dev,
                zlib1g-dev,
                libamgcl-dev,
+               libmeshb-dev,
+               librply-dev,
                doxygen
 Standards-Version: 4.6.0
 Homepage: https://github.com/BrunoLevy/geogram

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

# I disable various non-optional things for now. Let's get the core library
# working first
override_dh_auto_configure:
	dh_auto_configure -- \
		-DGEOGRAM_WITH_HLBFGS=OFF \
		-DGEOGRAM_WITH_GRAPHICS=OFF \
		-DGEOGRAM_WITH_EXPLORAGRAM=OFF \
		-DGEOGRAM_WITH_TETGEN=OFF \
		-DGEOGRAM_WITH_TRIANGLE=ON \
		-DGEOGRAM_USE_SYSTEM_GLFW3=ON

override_dh_auto_build:
	dh_auto_build
	$(MAKE) -C obj-$(DEB_HOST_GNU_TYPE) doc-devkit-full


# to pacify dh_missing
override_dh_auto_install:
	dh_auto_install
	rm debian/tmp/usr/doc/geogram/VERSION.txt
	rmdir debian/tmp/usr/doc/geogram

=== debian/watch ===
version=4
https://github.com/BrunoLevy/geogram/tags .*/v?(\d\S+)\.tar\.gz
